package InvalidateCodeMirror::CMS;

use strict;
use warnings;

sub invalidate_codemirror {
    my ($cb, $app, $template) = @_;

    my $old;
    my $new;

    if (MT->version_number >= 5.13) {
        $old = <<HERE;
<mt:setvarblock name="html_head" append="1">
HERE
        $old = quotemeta($old);

        $new = <<HERE;
<mt:setvarblock name="html_head" append="1">
<style>
.CodeMirror {
    display: none;
}
</style>
</mt:setvarblock>
<mt:setvarblock name="html_head" append="1">
HERE
        $$template =~ s/$old/$new/;
    }

    if (MT->version_number >= 5.1) {
        $old = <<HERE;
<mt:setvarblock name="html_head" append="1">
HERE
        $old = quotemeta($old);

        $new = <<HERE;
<mt:setvarblock name="html_head" append="1">
<style>
#textarea-enclosure {
    -moz-border-radius: 3px;
    border-width: 1px;
}
</style>
</mt:setvarblock>
<mt:setvarblock name="html_head" append="1">
HERE
        $$template =~ s/$old/$new/;

        $old = <<HERE;
    <div id="template-editor-toolbar" class="template editor-toolbar toolbar">
      <button type="button" id="syntaxon" class="command-highlight-on toolbar button active" title="Syntax Hightlight On"><span class="button-label">Syntax Hightlight On</span></button><button type="button" id="syntaxoff" class="command-highlight-off toolbar button" title="Syntax Hightlight Off"><span class="button-label">Syntax Hightlight Off</span></button>
    </div>
HERE
        $old = quotemeta($old);

        $new = <<HERE;
        <textarea tabindex="3" class="monospace" spellcheck="false" name="text2" id="text2" cols="" rows="" mt:watch-change="1" mt:editor="codemirror" mt:editor-options="lang:<mt:var name="template_lang"> autocomplete:off" /><mt:var name="text" escape="html"></textarea>
HERE
        $$template =~ s/$old/$new/;

        if (MT->version_number < 5.13) {
        $old = <<HERE;
var editor = CodeMirror.fromTextArea('text', {
    parserfile: parsers,
    stylesheet: ["<\$mt:var name="static_uri"\$>codemirror/css/xmlcolors.css", "<\$mt:var name="static_uri"\$>codemirror/css/jscolors.css", "<\$mt:var name="static_uri"\$>codemirror/css/csscolors.css"],
    path: "<mt:var name="static_uri">codemirror/js/",
    lineNumbers: true,
    textWrapping: false,
    tabMode: "default",
    indentUnit: 0,
    passDelay: 20,
    height: "550px",
    lang: "<mt:var name="language_tag">"
});
HERE
        $old = quotemeta($old);

        $new = <<HERE;
var editor = CodeMirror.fromTextArea('text2', {
    parserfile: parsers,
    stylesheet: ["<\$mt:var name="static_uri"\$>codemirror/css/xmlcolors.css", "<\$mt:var name="static_uri"\$>codemirror/css/jscolors.css", "<\$mt:var name="static_uri"\$>codemirror/css/csscolors.css"],
    path: "<mt:var name="static_uri">codemirror/js/",
    lineNumbers: true,
    textWrapping: false,
    tabMode: "default",
    indentUnit: 0,
    passDelay: 20,
    height: "0px",
    lang: "<mt:var name="language_tag">"
});
HERE
        $$template =~ s/$old/$new/;
        } else {
        $old = <<HERE;
var options = jQuery('#text').attr('mt:editor-options');
HERE
        $old = quotemeta($old);
        $new = <<HERE;
var options = jQuery('#text2').attr('mt:editor-options');
HERE
        $$template =~ s/$old/$new/;

        $old = <<HERE;
var editor = CodeMirror.fromTextArea(jQuery('#text').get(0), editor_params);
HERE
        $old = quotemeta($old);
        $new = <<HERE;
var editor = CodeMirror.fromTextArea(jQuery('#text2').get(0), editor_params);
HERE
        $$template =~ s/$old/$new/;
        }
        $old = <<HERE;
        syncEditor();
HERE
        $old = quotemeta($old);

        $$template =~ s/$old//g;

    } elsif (MT->version_number >= 5.01) {
        $old = <<HERE;
        <textarea tabindex="3" class="monospace" spellcheck="false" name="text" id="text" cols="" rows="" mt:watch-change="1" mt:editor="codemirror" mt:editor-options="lang:<mt:var name="template_lang"> autocomplete:off" /><mt:var name="text" escape="html"></textarea>
HERE
        $old = quotemeta($old);

        my $new = <<HERE;
<textarea tabindex="3" style="font-size:12px;" class="monospace" spellcheck="false" name="text" id="text" cols="" rows="30" /><mt:var name="text" escape="html"></textarea>
HERE
        $$template =~ s/$old/$new/;
    }
}

1;
